{-# LANGUAGE CPP #-}
{-# LANGUAGE NoRebindableSyntax #-}
{-# OPTIONS_GHC -fno-warn-missing-import-lists #-}
module Paths_libiserv (
    version,
    getBinDir, getLibDir, getDynLibDir, getDataDir, getLibexecDir,
    getDataFileName, getSysconfDir
  ) where

import qualified Control.Exception as Exception
import Data.Version (Version(..))
import System.Environment (getEnv)
import Prelude

#if defined(VERSION_base)

#if MIN_VERSION_base(4,0,0)
catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
#else
catchIO :: IO a -> (Exception.Exception -> IO a) -> IO a
#endif

#else
catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
#endif
catchIO = Exception.catch

version :: Version
version = Version [8,6,3] []
bindir, libdir, dynlibdir, datadir, libexecdir, sysconfdir :: FilePath

bindir     = "/usr/local/bin"
libdir     = "/usr/local/lib/x86_64-linux-ghc-8.6.3/libiserv-8.6.3"
dynlibdir  = "/usr/local/lib/x86_64-linux-ghc-8.6.3"
datadir    = "/usr/local/share/x86_64-linux-ghc-8.6.3/libiserv-8.6.3"
libexecdir = "/usr/local/libexec/x86_64-linux-ghc-8.6.3/libiserv-8.6.3"
sysconfdir = "/usr/local/etc"

getBinDir, getLibDir, getDynLibDir, getDataDir, getLibexecDir, getSysconfDir :: IO FilePath
getBinDir = catchIO (getEnv "libiserv_bindir") (\_ -> return bindir)
getLibDir = catchIO (getEnv "libiserv_libdir") (\_ -> return libdir)
getDynLibDir = catchIO (getEnv "libiserv_dynlibdir") (\_ -> return dynlibdir)
getDataDir = catchIO (getEnv "libiserv_datadir") (\_ -> return datadir)
getLibexecDir = catchIO (getEnv "libiserv_libexecdir") (\_ -> return libexecdir)
getSysconfDir = catchIO (getEnv "libiserv_sysconfdir") (\_ -> return sysconfdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
